VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "  "
   ClientHeight    =   5670
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   Icon            =   "main.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5670
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdView 
      Caption         =   " FailureActions:"
      Height          =   525
      Left            =   600
      TabIndex        =   3
      Top             =   1470
      Width           =   3525
   End
   Begin VB.ListBox lstValues 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2985
      Left            =   600
      TabIndex        =   2
      Top             =   2100
      Width           =   3525
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   " "
      Height          =   465
      Left            =   540
      TabIndex        =   1
      Top             =   750
      Width           =   3705
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   " "
      Height          =   465
      Left            =   540
      TabIndex        =   0
      Top             =   180
      Width           =   3705
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************'
' :    '
'***********************************'

'  
  Option Explicit '   

' :   
  Const NAME_SERVICE = "Calculator"       '  
  Const FILE_SERVICE = "calc.exe"         '   
  Const MANAGER_SERVICE = "instsrv.exe"   '    
  Const EMUL_SERVICE = "srvany.exe"       '  -  

' :  
Private Sub Form_Load()
  ' 
    '   
    cmdCreate.Caption = "  " & NAME_SERVICE & ""
    cmdDelete.Caption = "  " & NAME_SERVICE & ""
End Sub

' :   " "
Private Sub cmdCreate_Click()
  ' : 
    Dim strName As String '  
    Dim strExe As String  '    
  ' 
    '   
    strName = NAME_SERVICE
    '     
    strExe = cm.PathCorrect(App.Path) & FILE_SERVICE
    '  
    If CreateService(strName, strExe) Then
      MsgBox " " & strName & " !", vbInformation, ""
    Else
      MsgBox "      " & strName & "!", vbCritical, ""
    End If
End Sub

' :   " "
Private Sub cmdDelete_Click()
  ' : 
    Dim strName As String '  
  ' 
    '   
    strName = NAME_SERVICE
    '  
    If RemoveService(strName) Then
      MsgBox " " & strName & " !", vbInformation, ""
    Else
      MsgBox "      " & strName & "!", vbCritical, ""
    End If
End Sub

' :  
' strName -  
' strExe -    
'    
Private Function CreateService(strName As String, strExe As String) As Boolean
  ' : 
    Dim blnRes As Boolean '   
  ' : 
    Dim strPath As String '     
    Dim strEmul As String '    -  
  ' :  
    Dim enuSect As EnumRegEditSect '  
    Dim strKey As String           '  
  ' 
    '    
    blnRes = False
    '      
    strPath = cm.PathCorrect(App.Path) & MANAGER_SERVICE
    '     -  
    strEmul = cm.PathCorrect(App.Path) & EMUL_SERVICE
    '     
    If Not cm.RunAndWait(strPath & " " & strName & " " & strEmul, cm.sGetPath(strPath), 0) Then GoTo SubExit
    '   
    enuSect = enuHKEY_LOCAL_MACHINE
    '   
    strKey = "SYSTEM\CurrentControlSet\Services\" & strName & "\Parameters"
    '   "Parameters"
    If Not cm_RegEdit.CreateNewKey(enuSect, strKey) Then GoTo SubExit
    '  
    If Not cm_RegEdit.SetKeyValue(enuSect, strKey, "AppDirectory", cm.DirCorrect(cm.sGetPath(strExe)), enuREG_SZ) Then GoTo SubExit
    If Not cm_RegEdit.SetKeyValue(enuSect, strKey, "Application", strExe, enuREG_SZ) Then GoTo SubExit
    '    
    blnRes = True
SubExit:
    '  
    CreateService = blnRes
End Function

' :  
' strName -  
'    
Private Function RemoveService(strName As String) As Boolean
  ' : 
    Dim blnRes As Boolean '   
  ' : 
    Dim strPath As String '     
  ' 
    '    
    blnRes = False
    '  
    If Not StopService(strName) Then GoTo SubExit
    '      
    strPath = cm.PathCorrect(App.Path) & MANAGER_SERVICE
    '     
    If Not cm.RunAndWait(strPath & " " & strName & " REMOVE", cm.sGetPath(strPath), 0) Then GoTo SubExit
    '    
    blnRes = True
SubExit:
    '  
    RemoveService = blnRes
End Function

' :  
' strName -  
'    
Public Function StopService(strName As String) As Boolean
  ' : 
    Dim blnRes As Boolean '   
  ' 
    '    
    blnRes = False
    '  
    If Not cm.RunAndWait("net stop " & strName, cm.sGetPath(App.Path), 0) Then GoTo SubExit
    '    
    blnRes = True
SubExit:
    '  
    StopService = blnRes
End Function

' :   
' strName -  
'    
Public Function IsStartServer(strName As String) As Boolean
  ' : 
    Dim blnRes As Boolean   '   
  ' : 
    Dim varValue As Variant '  
  ' 
    '    
    blnRes = False
    ' ,     
    If Not IsCreateServer(strName) Then GoTo SubExit
    ' ,   Start  DenwerServer   2
    If cm_RegEdit.QueryValue(enuHKEY_LOCAL_MACHINE, "SYSTEM\CurrentControlSet\Services\" & strName, "Start") <> 2 Then GoTo SubExit
    '    
    blnRes = True
SubExit:
    '  
    IsStartServer = blnRes
End Function

' :   
' strName -  
'    
Public Function IsCreateServer(strName As String) As Boolean
  ' 
    '    "DenwerServer"
    IsCreateServer = cm_RegEdit.TestKey(enuHKEY_LOCAL_MACHINE, "SYSTEM\CurrentControlSet\Services\" & strName)
End Function

' :      
' strService -  
' strDepend - ,    
'    
Private Function CreateDepend(strService As String, strDepend As String) As Boolean
  ' : 
    Dim blnRes As Boolean '   
  ' : 
    Dim enuSect As EnumRegEditSect '  
    Dim strKey As String           '  
  ' 
    '    
    blnRes = False
    '   
    enuSect = enuHKEY_LOCAL_MACHINE
    '   
    strKey = "SYSTEM\CurrentControlSet\Services\" & strService
    '  
    If Not cm_RegEdit.SetKeyValue(enuSect, strKey, "DependOnService", strDepend, enuREG_MULTI_SZ) Then GoTo SubExit
    '    
    blnRes = True
SubExit:
    '  
    CreateDepend = blnRes
End Function

' :   "  FailureActions"
Private Sub cmdView_Click()
  ' : 
    Dim varValue As Variant '  
    Dim intCount As Integer '   
    Dim intItem As Integer  '   
  ' 
    '  
    lstValues.Clear
    '   
    varValue = cm_RegEdit.QueryValue(enuHKEY_LOCAL_MACHINE, "SYSTEM\CurrentControlSet\Services\" & NAME_SERVICE, "FailureActions")
    '    
    intCount = cm.LenArray(varValue)
    ' ,   
    If intCount = 0 Then
      ' 
      MsgBox "  FailureActions  !", vbInformation, " "
      '   
      Exit Sub
    End If
    '  
    With lstValues
      For intItem = 0 To intCount - 1
        '  ,     
        If varValue(intItem) <> 0 Then
          .AddItem "FailureActions(" & VBA.Format(intItem, "0") & ") = " & VBA.Format(varValue(intItem), "0")
        End If
      Next
    End With
End Sub

